/**
 * 企业服务
 */

import moment = require("moment");
import { FUHUASTATE, INDUSTRY, MOVEOUTTYPE, OPERATIONALDATATYPE, TABLENAME } from "../../config/enum";
import { selectData, selectManyTableData } from "./operationalData";


export async function getEnterprise() {
    let qyfw = {
        qyjbqk:{dataList:[], titleList:['key', 'value']},
        bhqsfx:[],
        rfscfb:{dataList:[], titleList:['key', 'value']},
        fhqyhylyzb:{dataList:[], titleList:['key', 'value']},
        qyrc:[],
    }

    let nowTime = new Date().valueOf();
    let selectParam = {"endTime":{"%gt%":nowTime}};
    let zlColumn = ["eId", "area", "unitPrice", "isDeposit", "startTime", "endTime", "rentFreeStart", "rentFreeEnd", "roomNumber", 
    "rent", "notes", "leaseContract", "entryPlan", "businessLicense", "agreement"];
    /**在孵：获取租赁结束时间大于当前时间的租赁信息 */
    let zldbList = await selectData(OPERATIONALDATATYPE.查询多个, TABLENAME.租赁信息, selectParam, zlColumn);

    let qyjbqk = {
        "孵化面积":0,
        "在孵企业":0,
        "毕业企业":0
    };
    zldbList.forEach( item => {
        qyjbqk.孵化面积 += parseInt(item.area);
    })

    let fhColumn = ["fId", "eId", "startTime", "endTime", "state", "virtualCause", "virtualCauseDes", "moveOutType", 
    "moveOutTrace", "moveOutCause", "moveOutTime", "graduationTime"];
    //获取所有企业孵化信息
    let fhdbList = await selectData(OPERATIONALDATATYPE.查询多个, TABLENAME.企业孵化信息, {}, fhColumn);
    //获取在孵企业
    let 在孵dbList = await selectData(OPERATIONALDATATYPE.查询多个, TABLENAME.企业孵化信息, {"endTime":{"%gt%":nowTime}}, fhColumn);
    //获取毕业企业
    let 毕业dbList = await selectData(OPERATIONALDATATYPE.查询多个, TABLENAME.企业孵化信息, {"moveOutType":MOVEOUTTYPE.毕业迁出}, fhColumn);
    //获取所有企业孵化表联查企业信息表
    let 孵化企业includeConf = {};
    let 孵化企业Clumn = ["enterpriseName", "industry"];
    孵化企业includeConf[TABLENAME.企业基础信息表] = {cloum:孵化企业Clumn, where:{}}
    let 孵化企业dbList = await selectManyTableData(OPERATIONALDATATYPE.多表联查, TABLENAME.企业孵化信息, {}, fhColumn, 孵化企业includeConf);

    qyjbqk.在孵企业 = 在孵dbList.length;
    qyjbqk.毕业企业 = 毕业dbList.length;

    qyfw.qyjbqk.dataList = getKeyValue(qyjbqk);

    
    let bhqsfx = {
        "在孵":[],
        "毕业":[]
    }

    //todo 变化趋势分析 需要日志表
    bhqsfx["在孵"] = [
        {key:"2019", value:4},
        {key:"2020", value:4},
    ];
    bhqsfx["毕业"] = [
        {key:"2019", value:4},
        {key:"2020", value:4},
    ];
    fhdbList.forEach( item => {
    })
    //入孵时长分布
    // let rfscfb = getRfscfx(fhdbList);

    //孵化企业行业领域占比
    for (let key in INDUSTRY) {
        let anyKey:any = key;
        if (isNaN(anyKey)) {
            let keyStr = key;
            let industry = INDUSTRY[key];
            let count = await selectData(OPERATIONALDATATYPE.查询数据量, TABLENAME.企业基础信息表, {industry}, null);
            qyfw.fhqyhylyzb.dataList.push({key:keyStr, value:count})
        }
    }
    
    let year = ["2019", "2020", "2021", "2022", "2023", "2024"];
    let qyrc = {
        "就业人数":[],
        "创业团队分布":[]
    }
    for (let i = 0; i < year.length; i++) {
        let dbData = await selectData(OPERATIONALDATATYPE.查询多个, TABLENAME.参保记录, {annual:year[i]}, null);
        let count = 0;
        dbData.forEach( info => {
            let {zhuanKe, benKe, yanJiuSheng, boShi, qiTa} = info;
            count += zhuanKe;
            count += benKe;
            count += yanJiuSheng;
            count += boShi;
            count += qiTa;
        })
        qyrc["就业人数"].push({key:year[i], value:count})
    }
    
    return qyfw;
}


/**
 * 入孵时长分布
 * @param data 
 */
function getRfscfx(data) {
    let nowTime = new Date().valueOf();
    let result = [];
    let rfscfx = {
        "即将到期":0, //3个月
        "1年以内":0,
        "1-2年":0,
        "2-3年":0,
        "3-4年":0
    };

    data.forEach( item => {
        let endTimeYear = item.endTime.getFullYear();
        let endTimeMonth = item.endTime.getMonth();

        if (item.endTime) {}
    })
}








function getKeyValue(data) {
    let result = [];
    for (let key in data) {
        result.push({key, value:data[key]});
    }

    return result;
}







